"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Data_1 = require("./Data");
const decorators_1 = require("../decorators");
class MySubClass extends Data_1.Data {
}
__decorate([
    decorators_1.Attribute()
], MySubClass.prototype, "id", void 0);
class MyClass extends Data_1.Data {
    resetDirtyStatePublic() {
        super.resetDirtyState();
    }
    dirtyAttributesPublic() {
        return super.getDirtyAttributes();
    }
}
__decorate([
    decorators_1.Attribute()
], MyClass.prototype, "name", void 0);
__decorate([
    decorators_1.Attribute.model(MySubClass)
], MyClass.prototype, "sub", void 0);
const instance1 = new MyClass({ name: 'my-name-1' });
const instance2 = new MyClass({ name: 'my-name-2', sub: {} });
test('Should load the constructor data into the class', () => {
    expect(instance1.name).toBe('my-name-1');
    expect(instance2.name).toBe('my-name-2');
    expect(instance2.dirtyAttributesPublic().length).toEqual(0);
    expect(instance2.dirtyAttributesPublic().length).toEqual(0);
});
test('Should update an attribute', () => {
    instance1.name = 'my-name-1-2';
    instance2.name = 'my-name-2-2';
    expect(instance1.name).toBe('my-name-1-2');
    expect(instance2.name).toBe('my-name-2-2');
    expect(instance1.dirtyAttributesPublic().length).toEqual(1);
    expect(instance2.dirtyAttributesPublic().length).toEqual(1);
    expect(instance1.dirtyAttributesPublic()).toEqual(['name']);
    expect(instance2.dirtyAttributesPublic()).toEqual(['name']);
});
test('Should reset the dirty state', () => {
    instance1.resetDirtyStatePublic();
    expect(instance1.dirtyAttributesPublic().length).toEqual(0);
});
test('Should update sub attributes', () => {
    instance1.sub.id = 'id';
    expect(instance1.dirtyAttributesPublic()).toEqual(['sub']);
});
test('Should partially update the object', () => {
    const newInstance = new MyClass({ name: 'name-1' });
    expect(newInstance.name).toBe('name-1');
    newInstance.set({});
    expect(newInstance.name).toBe('name-1');
});
//# sourceMappingURL=Data.spec.js.map