"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JoiOriginal = exports.Joi = void 0;
const JoiOriginal = require("joi");
exports.JoiOriginal = JoiOriginal;
const lodash_1 = require("./lodash");
// tslint:disable-next-line:variable-name
const Joi = JoiOriginal.extend((joi) => ({
    base: joi.object(),
    name: 'object',
    rules: [{
            name: 'model',
            validate(params, value, state, options) {
                try {
                    const optional = lodash_1._.get(this, '_flags.presence', 'required') === 'optional';
                    if (optional && lodash_1._.isEmpty(value.serialize())) {
                        return value;
                    }
                    return value.validate();
                }
                catch (e) {
                    return this.createOverrideError('object.domain', {}, state, options, e.message);
                }
            },
        }],
}));
exports.Joi = Joi;
//# sourceMappingURL=joi.js.map