"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorReporter = void 0;
const injector_1 = require("../injector");
const ERROR_REPORTER_NAME = 'airboat:function:error';
var ErrorReporter;
(function (ErrorReporter) {
    async function report(error, req) {
        if (!injector_1.Injector.has(ERROR_REPORTER_NAME)) {
            return false;
        }
        const reporterFunction = injector_1.Injector.get(ERROR_REPORTER_NAME);
        try {
            return await reporterFunction(error, req);
        }
        catch (e) {
            console.error(JSON.stringify({ type: 'FATAL ERROR', message: e.message, details: 'fatal error while trying to report an error' }));
        }
    }
    ErrorReporter.report = report;
})(ErrorReporter = exports.ErrorReporter || (exports.ErrorReporter = {}));
//# sourceMappingURL=index.js.map