"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initClassDataSymbols = exports.CLASS_DATA_ATTRIBUTES = void 0;
exports.CLASS_DATA_ATTRIBUTES = Symbol('metadata.attributes');
// If needed, create the attribute property on the class by extending the parent's properties
exports.initClassDataSymbols = (target) => {
    if (!Object.prototype.hasOwnProperty.call(target, exports.CLASS_DATA_ATTRIBUTES)) {
        Object.defineProperty(target, exports.CLASS_DATA_ATTRIBUTES, { value: deriveBaseSchema(target) });
    }
};
// Copy the attributes from the parent class
const deriveBaseSchema = (target) => {
    if (target && typeof target === 'object') {
        const prototype = Object.getPrototypeOf(target);
        if (prototype) {
            return Object.assign(Object.assign({}, deriveBaseSchema(prototype)), Object.prototype.hasOwnProperty.call(prototype, exports.CLASS_DATA_ATTRIBUTES) ? prototype[exports.CLASS_DATA_ATTRIBUTES] : {});
        }
    }
    return {};
};
//# sourceMappingURL=symbols.js.map