import { JoiOriginal } from './libs';
export interface ISearchQuery {
    query?: string;
    page?: number;
    size?: number;
    sort?: string;
}
export interface ITableObject {
    tableName: string;
    hashKey: string;
    rangeKey?: string;
    indexes?: Map<string, {
        rangeKey: string;
    }>;
}
export interface IIndexObject {
    indexName: string;
    workspaceId: string;
    objectId?: string;
}
export interface IEventObject {
    listenerParams: object;
    eventPayload: object;
    eventPath: string;
    listenerKey: string;
    listenerPath: string;
    retryCount: number;
    triggeredAt: Date;
}
export interface IDataObject {
}
export interface IAttribute {
    name?: string;
    serialize?: (v?: any) => any;
    deserialize?: (v?: any) => any;
    validation?: JoiOriginal.JoiObject;
}
export interface IAttributes {
    [key: string]: IAttribute;
}
export interface ILoggerContext {
    user?: {
        userId?: string;
        workspaceId?: string;
        permissions?: string[];
    };
    method?: 'GET' | 'POST' | 'PUT' | 'DELETE' | 'WORKER';
    path?: string;
    transactionName?: string;
    serviceName?: string;
    serviceType?: string;
}
